
function testSimpleCodeChanges(){
    console.log("testing simplme code changes");

    let origFile = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\renderer.js";
    let originalCode = fs.readFileSync(origFile, 'utf-8');  
    let newCode = `STUBS.loadSettings = async function(){
        storage.get('all_projects', function(error, data) {
            console.log("error");
            console.log(error);
            console.log("projects");
            console.log(data);

            if (data && data.all_projects) {
                data.all_projects.forEach(project => {
                    console.log('Project Name: ' + project.name);
                    console.log('Project Folder: ' + project.folder);
                    console.log('Project Description: ' + project.description);
                    console.log('LLM Rules: ' + project.llm_rules);
                    console.log('---');
                });
            }
        });     

        // ... existing code
    };`;

    let modFile = DIFFR.simpleCodeChanges(originalCode, newCode);
    console.log("afterwards file:");
    console.log(modFile);
    
}

$(document).ready(function () {
    $('#test_clear_all_projects').on('click', function() {
        storage.remove('all_projects', function(error) {
          if (error) throw error;
          console.log('All projects cleared successfully');
          // Refresh the project list or perform any other necessary actions
        });
    });

    //testSimpleCodeChanges();
    
    $('#test_loading_response').on('click', async function(){
        await mysqlLogger.initDatabase(mysqlConfig);   
        let theTask = await mysqlLogger.getLatestTaskByRequestType('do_new_programming_task');
        if(theTask){
            $('#chatgpt-request').val(theTask);
            setTimeout(function(){
                $('#send_button').trigger('click');                
            }, 100);
        }
        
        
        
    });
  
    $('#test_mysql_connection').on('click', async function() {
        /*
        let mysqlConfig = {
            host: 'ec2-107-23-253-169.compute-1.amazonaws.com',
            port: 3306,
            user: 'scrapeuser2',
            password: 'xxx',
            database: 'scrapehawk'
        };

        let isConnected = await mysqlConn.testConnection(mysqlConfig);
        if (isConnected) {
            console.log('MySQL connection successful');
        } else {
            console.log('MySQL connection failed');
        }
        */
       
       
        const connections = await ipcRenderer.invoke('get-connections');
        console.log('MySQL connections1111:');
        console.log(connections);
        console.log("length" + Object.keys(connections).length);
        if (Object.keys(connections).length > 0) {
            const connectionName = Object.keys(connections)[0];            
            const connection = connections[connectionName];

            if (!mysqlConn.databaseConnected) {
                console.log("initing database");
                let mysqlConfig = {
                    host: connection.host,
                    user: connection.user,
                    password: connection.password,
                    database: connection.database                    
                };
                await mysqlConn.initDatabase(mysqlConfig);
            }            
            const schemas = await mysqlConn.getSchemas();
            console.log('Schemas:', schemas);

            const defaultSchema = connection.database;
            const tables = await mysqlConn.getTables(defaultSchema);
            console.log(`Tables in schema ${defaultSchema}:`, tables);
        } else {
            console.log('No MySQL connections found');
        }            
        
    });  
  
    /*
    async function generateDependencies(projectName, finalOriginalPaths){


        let doesItWork = await DGRAPH.getDependenciesForProject(finalOriginalPaths);
        
        let dGraphArr = doesItWork[0];
        let dependencyGroups = doesItWork[1];
        console.log("graph count" + dGraphArr.length);
        
        
        console.log("saving graph");
        await dexieDB.saveDependencyGraph(projectName, dGraphArr);
        console.log("saving group");        
        await dexieDB.saveDependencyGroups(projectName, dependencyGroups);    
        console.log("generated dependencies");
        
        return doesItWork;
    }
    */
   
   $('#test_related_files').on('click', async function(){
        let relatedFiles = await DGRAPH.getRelatedFiles(lineNumberArr, myProjectArr[0]);
        for (let file of relatedFiles) {
            if (!stubFilesArr.includes(file)) {
                stubFilesArr.push(file);
            }
        }       
   });
   
   $('#test_formalize_changes').on('click', async function(){
       /*
       let formalizeId = 1577;
       let formlizeResponse = await mysqlLogger.getResponseById(formalizeId);
       console.log("formalize response");
       console.log(formlizeResponse);
       */
        let thePrompt = fs.readFileSync(path.join(STUBS.appPath, 'prompts', 'new_code_placement.txt'), 'utf-8');
        let stubFile = "TEST IT";
        let newCode = "newCode";
        let assistantMessage = "Ass Message";
        let fullPrompt = Mustache.render(thePrompt, {
            stubFile: stubFile,
            newCode: newCode,
            assistantMessage: assistantMessage
        });      
        
        console.log("FULL PROMPT RESULT");
        console.log(fullPrompt);
        
      
   });
   
   $('#load_idapply').on('click', async function(){
        const replayId = $('#replay_id').val();
        let tabUid = TABS.getCurrentUid();
        let tabIndex = TABS.getIndexByUid(tabUid);   
        
        if (replayId) {
            const applyChangesLog = await mysqlLogger.getApplyChangesById(replayId);
            console.log('Apply Changes Log:', applyChangesLog);
            // Parse the stored JSON strings
            const allRelevantText = applyChangesLog.all_relevant_text;
            const assistantMessage = applyChangesLog.assistant_message;
            const finalOriginalPaths = JSON.parse(applyChangesLog.final_original_paths);
            const finalShortPaths = JSON.parse(applyChangesLog.final_short_paths);
            const justFilesLinux = JSON.parse(applyChangesLog.just_files_linux);
            const myProjectData = JSON.parse(applyChangesLog.my_project_data);
            const filesSnapshot = JSON.parse(applyChangesLog.files_snapshot);

            // Extract myProjectArr, myProjectPathArr, and myProjectDescArr from myProjectData
            const { my_project_arr: myProjectArr, my_project_path_arr: myProjectPathArr, my_project_desc_arr: myProjectDescArr } = myProjectData;
            
            STUBS.APPLY_FILE_OVERRIDES = filesSnapshot;
            
            for(let snapKey in filesSnapshot){
                //console.log("snapkey " + snapKey);
                //console.log("snapcontent " + filesSnapshot[snapKey]);
                STUBS.FILE_CACHE.set(snapKey, filesSnapshot[snapKey]);
            }
            
            
            let CHANGE_MY_PROJECT_NAME = myProjectArr[0];
            let CHANGE_MY_PROJECT_PATH = myProjectPathArr[0];
            let CHANGE_MY_PROJECT_DESC = myProjectDescArr[0];
            
            //SAVE ID of doNewProgrammingTask to get this???
            //NO TASK NEEDED?
            //NO TASK NEEDED?
            //NO TASK NEEDED?
            
            let myTask = "";

            let changesSucceeded = false;

            // Determine which apply changes method to use (you may want to add a way to select this)
            if (STUBS.APPLY_CHANGES_BY === 'piecemeal') {
                STUI.updateLoaderText("Applying Changes (Piecemeal)");
                changesSucceeded = await applyPiecemealCodeChanges(tabUid, allRelevantText, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, myProjectArr, myProjectPathArr, myProjectDescArr);
                $('#reapply_changes').html("Redo w Formalize");
            } else if (STUBS.APPLY_CHANGES_BY === 'simple') {
                STUI.updateLoaderText("Applying Changes (SIMPLE)");
                changesSucceeded = await applySimpleCodeChanges(tabUid, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, CHANGE_MY_PROJECT_NAME, CHANGE_MY_PROJECT_PATH);
            } else if (STUBS.APPLY_CHANGES_BY === 'formalized') {
                STUI.updateLoaderText("Applying Changes (Formalized)");
                $('#reapply_changes').html("Redo w Piecemeal");
                console.log("REAPPLYING CHANGES");
                console.log(myProjectArr);
                console.log(myProjectPathArr);
                console.log(myTask);
                console.log(tabUid);
                console.log(allRelevantText);
                console.log(assistantMessage);
                
                changesSucceeded = reapplyUsingFormalizedChanges(myProjectArr, myProjectPathArr, myTask, tabUid, allRelevantText, assistantMessage);        
            } else {
                alert("Unknown application method");
            }

            STUI.stopLoader();
            $('#reapply_changes').css('display', 'block');     
            if (changesSucceeded) {
                STUBS.CURRENT_TASK_COUNT++;
                $('#task_count').text(STUBS.CURRENT_TASK_COUNT);       
            } else {
                STUI.loaderError("Error Applying Changes");
            }            
            
            
        } else {
            console.log('Please enter a valid replay ID.');       
        }
   });
    
    $('#test_file_descriptions').on('click', async function(){
      
      if(!STUBS.STUBS_LOADED){
          alert("Please wait a second for Stub files to be generated/synced");
          return;
      }
      let projectName = "Stubs";
      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();  
       
      let projectDesc = "Electron node.js application that allows you to request code completion tasks from LLMs, and provides an interface to approve those code changes.";    
      let projectPath = checkedProjectPaths[0];
      
        let isReady = await EMBED.embeddingsReadyOrCreate(projectName, projectDesc, projectPath);
        if(isReady){
            let documents = await EMBED.getDocumentsArray();
            let onlyFilepaths = new Array();
            for(let f = 0; f < documents.length; f++){
                onlyFilepaths.push(documents[f]['filename']);
            }
            console.log("document array");
            console.log(documents);
            
            //adfksljlasdfljsdfsadflkj dasflj adfslkasfjlfasd jdsfalj sdf
            
            const embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
            await dexieDB.saveEmbeddingsToDexie(projectName, embeddings, onlyFilepaths);        
        }else{
            console.log("not ready");
        }
        /*
        let docs = new Array();
        
        
        for(let x = 0; x < finalOriginalPaths.length; x++){
            
            let fPath = finalOriginalPaths[x];
            let sPath = finalShortPaths[x];
            let theDescription = "";
            let depArr = new Array();
            let codeContent = await fs.readFile(fPath, 'utf8');
            let foundDesc = false;
            for(let m = 0; m < existingDescriptions.length; m++){
                let myPath = existingDescriptions[m].file_path;
                if(!myPath){
                    continue;
                }
                if(comparePaths(myPath, sPath)){
                    foundDesc = true;
                    theDescription = existingDescriptions[m].description;
                }
            }
            let foundDepArr = false;
            for(let d = 0; d < existingDependencies.length; d++){
                let shortDepPath = path.normalize(existingDependencies[d].filepath.replace(checkProjectPath, '')).replace(/\\/g, '/');
                console.log("short dep path");
                console.log(shortDepPath);
                if(comparePaths(shortDepPath, sPath)){
                    foundDepArr = true;
                    depArr = existingDependencies[d].dependencyLines;
                }                                                
            }
            if(!foundDesc){
                console.log("DESCRIPTIONS - DID NOT FIND " + sPath);
            }
            if(!foundDepArr){
                console.log("DEPENDENCIES - DID NOT FIND " + sPath);
            }
            

            let theCode = "";
            let newDoc = {filename: sPath,
                code: codeContent, 
                description: theDescription,
                dependencies: depArr
            };
            docs.push(newDoc);
            
            if(x > 3){
                break;
            }
            //`${doc.filename}\n${doc.description}\n${doc.dependencies.join("\n")}`;
        }
        
        console.log("Embedding Docs");
        console.log(docs);
                
        let theEmbeddings = xEmbeddings.generateEmbeddings(projectName, docs);
        */
        
        //let documents = await EMBED.getDocumentsArray(checkProjectPath, finalOriginalPaths, finalShortPaths, existingDependencies, existingDescriptions);
        //console.log("Done Embedding DOCS");
        //console.log(theEmbeddings);
        //
        
        //await dexieDB.saveEmbeddingsToDexie(projectName, theEmbeddings);
        
        

    });
    
    
    $('#test_step1_embeddings').on('click', async function(){
        //testSimpleEmbeddings();
        
    
        console.log("testing getting embeddings");
        const embeddings = await dexieDB.getEmbeddingsFromDexie("Stubs");
        console.log("got embeddings");
        console.log(embeddings);
        
        let allVectorData = new Array();
        let allFilePaths = new Array();
        for(let x = 0; x < embeddings.length; x++){
            allVectorData.push(embeddings[x]['vector_data']);
            allFilePaths.push(embeddings[x]['filename']);
        }

        console.log("vector data");
        console.log(allVectorData);
        console.log("docFiles");
        console.log(allFilePaths);
        
        
        let projectName = "Stubs";
        let projectDesc = "Electron node.js application that allows you to request code completion tasks from LLMs, and provides an interface to approve those code changes.";
        let query = "The redo button should bring back the #chatgpt-request-container and allow editing.  It should hide the .replace_chatgpt_request because that was added for when a request was sent.  The code for this should be in  index.html and ui_handlers.js Then what it does is clear out any variables there were saved in the tabmanager for that tab and remove the chatgpt response container, so then when press the send button it does fullNewTask again.";
        const mostSimilarIndices = await ipcRenderer.invoke('findMostSimilarDocumentIndices', query, allVectorData, 5);
        let mostSimilarDocuments = mostSimilarIndices.map((index) => allFilePaths[index]);        
        
        console.log("most similar");
        console.log(mostSimilarDocuments);
        
    });
    
    $('#test_newapi').on('click', function(){
        CHATGPT.testStreaming();
    });
    
    $('#test_start_debugger').on('click', async function(){
        console.log("sentry server initiate");
        ipcRenderer.send('setupDebugListener');
        
        setTimeout(function(){
            console.log("starting sentry in renderer");
            initializeDebugLogger('stubs');
        }, 1000);

        let thePrompt = fs.readFileSync(path.join(STUBS.appPath, 'prompts', 'request_architecture_topology.txt'), 'utf-8');

        let stubFilesTxt = "Test Files";
        let depGraphTxt = "Test Dependencies";

        fullPrompt = Mustache.render(thePrompt, {
            stubFiles: stubFilesTxt,
            dependencyGraphPrintout: depGraphTxt
        });        
        
    });
    
    
    $('#test_completion').on('click', function(){
       let theTask = "Can you tell me what this unix time is in human readable format: " + new Date().getTime().toString();
       CHATGPT.testNormalCompletion(theTask);
    });
    
    
    $('#test_get_filetext').on('click', async function(){
        let assistantMessage = `|js/chatgpt.js|
 CHATGPT.updateHtmlText = async function(newText, tabUid){
 CHATGPT.postProcessHtmlText = function(outputHtml, tabUid){
 CHATGPT.finalizeHtmlText = function(tabUid){
 
 |views/chat_response_container.html|
 <div id="chatgptresponse_{{tabUID}}" class="chatgpt-response"></div>
 
 |css/styles.css|
 .chatgpt-response-container
 .chatgpt-response
 .copybuttoncontainer
 .copy-button`;
        
        let lineNumberArr = CHATGPT.parseStubFileLines(assistantMessage); 
        let {checkedProjects, checkedProjectPaths, checkedProjectDescriptions} = SFILE.getCheckedProjects();      
        
        let projectFileData = await SFILE.getAvailableFilesForGPT(checkedProjects, STUBS.stubsData);   
        console.log("project file data");
        console.log(projectFileData);
        
        let CHANGE_MY_PROJECT_NAME = checkedProjects[0];
        console.log("project name");
        console.log(CHANGE_MY_PROJECT_NAME);

        let fileRefText = await CHATGPT.parseLineNumbers(lineNumberArr, CHANGE_MY_PROJECT_NAME, STUBS.stubsData);
        //console.log("Final context data");    
        //console.log(fileRefText);
        //await gotosleep(2000);      
        let allRelevantText = fileRefText['all_relevant_text'];
        let allFileData = fileRefText['all_data'];

        let badLines = fileRefText['bad_lines'];
        
        console.log("TESTING GETTING RELEVANT TEXT FROM");
        console.log(assistantMessage);
        
        console.log("RELEVANT");
        console.log(allRelevantText);        
        
        //mysqlLogger.getResponseByRequestTypeAndUid();
    });
    
    
    $('#test_code_parsing').on('click', async function(){
let assistantMessage = `To achieve the desired functionality, we need to update the \`framework\\libs\\output.php\` file to override the same variables for the \`$this->current_theme\` if there is currently an active event. We will use the logic from \`framework\\classes\\home.php\` to check for active events and override the theme variables accordingly.
Here is the updated code for \`framework\\libs\\output.php\`:
\`\`\`php
framework\\libs\\output.php
<?php
//... existing code
public function __construct()
{
    //... existing code
    $this->current_theme = Model_Themes::get_theme_by_time($this->current_theme_start);
    $this->themes_nav = Model_Themes::get_all_themes();
    // Get active events in the next week
    $activeEvents = Model_Events::get_active_events_in_next_week();
    // Override theme variables if an event is active for the day
    $eventDate = strtotime($this->current_theme_start);
    foreach ($activeEvents as $event) {
        $eventStartDate = strtotime($event['start_date']);
        $eventEndDate = strtotime($event['end_date']);
        if ($eventDate >= $eventStartDate && $eventDate <= $eventEndDate) {
            $this->current_theme['color_class'] = $event['color'];
            $this->current_theme['singular_name'] = $event['title'];
            // Get a random banner image from the event
            $bannerImages = array_filter([
                $event['banner_image1'],
                $event['banner_image2'],
                $event['banner_image3'],
                $event['banner_image4'],
                $event['banner_image5'],
                $event['banner_image6']
            ]);
            $this->current_theme['random_image'] = $bannerImages[array_rand($bannerImages)];
            break;
        }
    }
    //... existing code
}
//... existing code
?>
\`\`\``;
        
let assistantMessage2 = `To complete the task, we need to make changes to two files: \`js\\ui_modal_handlers.js\` and \`js\\dexiedatabase.js\`.

### Changes in \`js\\ui_modal_handlers.js\`

We need to modify the code to check the value of \`CHATGPT.DB_LOGGING\`. If it is false, we will fetch the data from Dexie instead of MySQL.

\`\`\`javascript
// js\\ui_modal_handlers.js

// Import the necessary modules
const dexieDB = require('./dexiedatabase');
const mysqlLogger = require('./mydatabase');

//... existing code

$('body').on('click', '#debug_request_button', async function(){
    let tabUid = TABS.getCurrentUid();
    let tabIndex = TABS.getIndexByUid(tabUid);      
    let allRequests;

    if (CHATGPT.DB_LOGGING) {
        allRequests = await mysqlLogger.getAllRequestsByUid(tabUid);
    } else {
        allRequests = await dexieDB.getAllRequestsByUid(tabUid);
    }

    console.log("allRequests is");
    console.log(allRequests);

    if(!allRequests || allRequests.length <= 0){
        let latestTask;
        if (CHATGPT.DB_LOGGING) {
            latestTask = await mysqlLogger.getLatestResponseByRequestType('do_new_programming_task');
        } else {
            latestTask = await dexieDB.getLatestResponseByRequestType('do_new_programming_task');
        }

        console.log(latestTask);
        let theUid = latestTask.uid;

        console.log("using latest uid");
        console.log(theUid);

        if (CHATGPT.DB_LOGGING) {
            allRequests = await mysqlLogger.getAllRequestsByUid(theUid);
        } else {
            allRequests = await dexieDB.getAllRequestsByUid(theUid);
        }

        console.log("requests");
        console.log(allRequests);
    }

    let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_debug_prompts.html'), 'utf-8');
    let debugPromptsModal = Mustache.render(modalHtml);
    $('body').append(debugPromptsModal);            

    // Clear existing prompts
    $('#debug_prompts_container').empty();

    // Loop through each request and add a textarea with the full_prompt
    for(let i = 0; i < allRequests.length; i++) {
        let fullPrompt = allRequests[i].full_prompt;
        let assistantMessage = allRequests[i].assistant_message;
        let requestType = allRequests[i].request_type;

        // Escape the text and wrap it in <pre> tags
        let escapedFullPrompt = $('<div/>').text(fullPrompt).html();
        let escapedAssistantMessage = $('<div/>').text(assistantMessage).html();
        let preFormattedFullPrompt = \`\${escapedFullPrompt}\`;
        let preFormattedAssistantMessage = \`\${escapedAssistantMessage}\`;

        $('#debug_prompts_container').append(\`
            <div id="pdebug_\${i}" class="prompt_debug">
                <div class="prompt-debug-header">
                    <div>\${requestType}</div>
                    <div>
                        <a class="toggle-prompt active" data-target="assistant_message_\${i}"><i class="ti ti-message"></i></a>
                        <a class="toggle-prompt" data-target="full_prompt_\${i}"><i class="ti ti-robot"></i></a>          
                        <a class="copydebug stubs_btn stubs_btn_outline-primary stubs_btn-sm" data-debug-id="\${i}">Copy</a>
                    </div>
                </div>
                <textarea id="full_prompt_\${i}" class="pdebug_text full_prompt_textarea" rows="3">\${preFormattedFullPrompt}</textarea>
                <textarea id="assistant_message_\${i}" class="pdebug_text assistant_message_textarea" rows="3" style="display: none;">\${preFormattedAssistantMessage}</textarea>
            </div>
        \`);
    }        

    // Show the modal
    MicroModal.show('modal_debug_prompts', {
        debugMode: true,
        disableScroll: true,
        onShow: function (modal) { },
        onClose: function (modal) { },
        awaitCloseAnimation: true
    });
});

//... existing code
\`\`\`

### Changes in \`js\\dexiedatabase.js\`

We need to add a function to fetch all requests by UID from Dexie, similar to the one in \`js\\mydatabase.js\`.

\`\`\`javascript
// js\\dexiedatabase.js

//... existing code

async function getAllRequestsByUid(uid) {
  try {
    const rows = await db.chatgpt_responses
      .where('uid')
      .equals(uid)
      .toArray();

    if (rows.length === 0) {
      return null;
    }
    return rows;
  } catch (err) {
    console.error('Error getting task by request type and uid:', err);
    return null;
  }
}

async function getLatestResponseByRequestType(requestType) {
  try {
    const rows = await db.chatgpt_responses
      .where('request_type')
      .equals(requestType)
      .reverse()
      .limit(1)
      .toArray();

    if (rows.length === 0) {
      return null;
    }

    return rows[0];
  } catch (err) {
    console.error('Error getting latest task by request type:', err);
    return null;
  }
}

//... existing code

module.exports = {
  //... existing exports
  getAllRequestsByUid,
  getLatestResponseByRequestType,
  //... existing exports
};
\`\`\`

### Explanation

1. **\`js\\ui_modal_handlers.js\`**:
   - We added a check for \`CHATGPT.DB_LOGGING\` to decide whether to fetch data from MySQL or Dexie.
   - If \`CHATGPT.DB_LOGGING\` is false, we use the new functions from \`dexiedatabase.js\` to fetch the data.

2. **\`js\\dexiedatabase.js\`**:
   - We added \`getAllRequestsByUid\` and \`getLatestResponseByRequestType\` functions to fetch data from Dexie.
   - These functions are similar to the ones in \`js\\mydatabase.js\` but adapted for Dexie.

These changes ensure that the application can switch between MySQL and Dexie based on the value of \`CHATGPT.DB_LOGGING\`.`;
        let pythonChanges = `To upgrade main.py to Python 3, we need to make several changes. Here are the key modifications along with explanations:

main.py
\`\`\`python
#!/usr/bin/env python3

# ... existing imports ...

import urllib.request  # Python 3 import for urllib

# ... existing code ...

def download_file(local_filename, url):
    # Use urllib.request.urlretrieve for Python 3
    urllib.request.urlretrieve(url, local_filename)
    return local_filename

# ... existing code ...

class ProgressPercentage(object):
    def __call__(self, bytes_amount):
        # To simplify we'll assume this is hooked up
        # to a single filename.
        with self._lock:
            self._seen_so_far += bytes_amount
            percentage = (self._seen_so_far / self._size) * 100
            print("percentage now: {}".format(percentage))  # Use string formatting

# ... existing code ...

if __name__ == "__main__":
    # ... existing code ...

    while True:
        try:
            # ... existing code ...
        except Exception as e:  # Catch specific exception
            print("Unknown Error check logs: {}".format(str(e)))
        finally:
            print("sleeping 1 min")
            time.sleep(60)

    print("EXITED LOOP HOW???")

    sys.exit(0)  # Use explicit exit code
\`\`\`

Explanation of changes:

1. Changed shebang to \`#!/usr/bin/env python3\` to explicitly use Python 3.
2. Updated \`urllib\` import to \`urllib.request\` for Python 3 compatibility.
3. Modified \`download_file\` function to use \`urllib.request.urlretrieve\`.
4. Updated string formatting to use the \`.format()\` method, which is more Pythonic and compatible with both Python 2 and 3.
5. In the main loop, caught a specific \`Exception\` and included the error message in the print statement.
6. Added an explicit exit code \`0\` to \`sys.exit()\` at the end of the script.`;     
        /*
        let justFilesLinux = ['framework/libs/output.php', 'framework/views/home.tpl', 'index.php'];        
        let allCodeChanges = DIFFR.parseCodeChanges(assistantMessage, justFilesLinux);
        
        console.log("testing all code changes");
        console.log(allCodeChanges);
        */
      
        //let justFilesLinux2 = ['js/ui_handlers.js', 'js/dexiedatabase.js', 'js/ui_modal_handlers.js', 'js/mydatabase.js', 'main.js', 'index.html'];        
        //let allCodeChanges2 = DIFFR.parseCodeChanges(assistantMessage4, justFilesLinux2);
        //console.log("testing all code changes");
        //console.log(allCodeChanges2);        
        
        let justFilesLinux = ['main.py', 'ffmpeg.py', 'cwscraper/CWScraper.py'];
        let allCodeChangesPython = DIFFR.parseCodeChanges(pythonChanges, justFilesLinux);
        console.log("testing all code changes");
        console.log(allCodeChangesPython);                
        
        
    });
    
    
    $('#test_scope_creation').on('click', async function(){

        console.log("======================   TESTING SCOPE CREATION ===========================");        
        console.log("============================================================================");
        console.log("============================================================================");        
        console.log("============================================================================");        
        console.log("============================================================================");        
        console.log("============================================================================");        
        console.log("============================================================================");        
        
        let test = ` //...
 
 console.log("=====================");
 console.log("STEP 2");
 
 // Get the function names from the stub lines
 let stubFunctionNames = lineNumberArr.map(line => {
   let [file, lineNumber] = line.split(':');
   let functionName = extractFunctionNameFromLine(file, parseInt(lineNumber));
   return functionName;
 }).filter(name => name !== null);
 
 console.log("Stub function names:");
 console.log(stubFunctionNames);
 
 // Get the related functions from the dependency graph
 let relatedFunctions = await DGRAPH.getRelatedFunctionsForStubFunctions(stubFunctionNames, CHANGE_MY_PROJECT_NAME);
 console.log("Related functions from dependency graph:");
 console.log(relatedFunctions);
 
 let lineNumberResponse = await CHATGPT.requestRelevantStubLines(myTask, theFilesTextLinux, stubFilesResult, tabUid);
 //...`;
        
        let test2 = `$('body').on('click', '#add_embeddings_context', function(){
    if($('#modal_create_embeddings').length > 0){
        $('#modal_create_embeddings').remove();
    }        

    let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_create_embeddings.html'), 'utf-8');
    let addEmbeddingModal = Mustache.render(modalHtml);
    $('body').append(addEmbeddingModal);    

    setTimeout(function(){
        MicroModal.show('modal_create_embeddings',
        {
            debugMode: true,
            disableScroll: true,
            onShow: function (modal) {  },
            onClose: function (modal) {  },
            awaitCloseAnimation: true
        });
    }, 100);        
});

$('body').on('click', '#modal_create_embeddings_submit', async function(){
    const embeddingName = $('#embedding_name').val();
    const embeddingText = $('#embedding_text').val();
    const currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];

    if(!currentTab.documentation_embeddings){
        currentTab.documentation_embeddings = [];
    }
    
    // Save the embedding to Dexie
    await dexieDB.saveDocumentationEmbedding(embeddingName, embeddingText);

    currentTab.documentation_embeddings.push({name: embeddingName, text: embeddingText});

    MicroModal.close('modal_create_embeddings');
    updateEmbeddingList();
});

function updateEmbeddingList() {
    const currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
    const embeddingList = $('#embedding_list');
    embeddingList.empty();

    if (currentTab.documentation_embeddings && currentTab.documentation_embeddings.length > 0) {
        currentTab.documentation_embeddings.forEach(embedding => {
            embeddingList.append('<option value="' + embedding.name + '">' + embedding.name + '</option>');
        });
    }
}

let heyMan = "What";
let weCool = "HopeSo";
let myObject = {
    what: 'you',
    say: 'now'
};

$('body').on('change', '#embedding_list', function(){
    const selectedEmbedding = $(this).val();
    const currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
    
    if (selectedEmbedding) {
        currentTab.use_documents = true;
        currentTab.document_text = selectedEmbedding;
    } else {
        currentTab.use_documents = false;
        currentTab.document_text = "";
    }
});

`;  
        
let test3 = `public function index($documentUrl, $args = null){
     $template = $this->template;        
 
     if(empty($documentUrl)){
         $documentUrl = "index";
     }
 
     $templateLocation = "docs/{$documentUrl}.tpl";
 
     if(!file_exists(_SITE_PATH . "/framework/views/{$templateLocation}")){
         // If the requested page doesn't exist, show a 404 error
         header("HTTP/1.0 404 Not Found");
         $templateLocation = "docs/404.tpl"; 
     }
     
     $this->page_template = $templateLocation;
     
     parent::render();
 }`;
        
 let test4 = `db.version(1).stores({
  chatgpt_requests: '++id, user_id, request_type, current_task, full_prompt, assistant_message, ret_data, request_date, llm_provider, model',
  chatgpt_responses: '++id, user_id, request_type, current_task, full_prompt, assistant_message, ret_data, request_date, uid, llm_provider, model',
  dependency_graph: '++id, project, caller, line_caller, callee, line_callee, type, name, parent_function',
  dependency_groups: '++id, project, group_index, file_paths',
  file_descriptions: '++id, project_name, file_path, description, update_date, md5, last_modified_date',
  embeddings: '++id, project_name, vector_data, update_date',
  documentation_embeddings: '++id, embeding_name, url_list, vector_data, update_date',
  stub_files: '++id, md5, line_count, needs_stub, is_included, full_path, file_path, filename, project_name, stub_file',
  debug_data: '++id, project, message_type, message_body, error, stack_trace, timestamp',
  apply_changes_log: '++id, all_relevant_text, assistant_message, final_original_paths, final_short_paths, just_files_linux, my_project_data, files_snapshot'
});`;
        
let test5 = `                        //DO INDENTATION HERE
                        let originalIndentation = contentLines[originalFileStart - 1].match(/^\s*/)[0];
                        
                        let replaceLines = replaceCode.split('\n');

                        // Add the original indentation to the first line of replaceLines
                        if (replaceLines.length > 0) {
                            replaceLines[0] = originalIndentation + replaceLines[0];
                        }

                        // Use the spread operator to pass the replaceLines as separate arguments to splice
                        contentLines.splice(originalFileStart - 1, originalFileEnd - originalFileStart + 1, ...replaceLines);
                        modifiedContent = contentLines.join('\n');
`;     
        
let test6 = `framework\libs\output.php
<?php
//... existing code

public function __construct()
{
    //... existing code

    $this->current_theme = Model_Themes::get_theme_by_time($this->current_theme_start);
    $this->themes_nav = Model_Themes::get_all_themes();

    // Get active events in the next week
    $activeEvents = Model_Events::get_active_events_in_next_week();

    // Override theme variables if an event is active for the day
    $eventDate = strtotime($this->current_theme_start);
    foreach ($activeEvents as $event) {
        $eventStartDate = strtotime($event['start_date']);
        $eventEndDate = strtotime($event['end_date']);

        if ($eventDate >= $eventStartDate && $eventDate <= $eventEndDate) {
            $this->current_theme['color_class'] = $event['color'];
            $this->current_theme['singular_name'] = $event['title'];

            // Get a random banner image from the event
            $bannerImages = array_filter([
                $event['banner_image1'],
                $event['banner_image2'],
                $event['banner_image3'],
                $event['banner_image4'],
                $event['banner_image5'],
                $event['banner_image6']
            ]);
            $this->current_theme['random_image'] = $bannerImages[array_rand($bannerImages)];

            break;
        }
    }

    //... existing code
}

//... existing code
?>`;        
        
let test7 = `<?php

//... existing code

$class_name = $url->class_name;
//... existing code

if (!file_exists(_CLASSES . "{$class_name}.php")) {
    switch ($class_name) {
        case '':
            $uri = 'home';
            $class_name = 'home';
            break;
        default:
            $dayTheme = Model_Themes::get_theme_by_url($class_name); 
            if(!empty($dayTheme)){
                $class_name = 'dailytheme';                                  
                $class = new $class_name($url);
                $class->is_dailytheme = true;
                $class->daily_theme = $dayTheme;
                $class->index($action);
                $class->setUrl($url);
                echo $class;
                DB::close();
                exit;
            }       

            $event = Model_Events::get_event_by_url($class_name);
            if(!empty($event)){
                $class_name = 'dailytheme';                                  
                $class = new $class_name($url);
                $class->is_dailytheme = true;
                $class->daily_theme = $event;
                $class->index($action);
                $class->setUrl($url);
                echo $class;
                DB::close();
                exit;
            }

            $station = null;
            //... existing code
    }
}

//... existing code

?>`; 
        
let test8 = `<?php

class documentation extends page{
    //put your code here
    public function __construct() {
        parent::__construct();
        $this->is_documentation = true;
    }

    public function index($documentUrl, $args = null){
        $template = $this->template;        

        if(empty($documentUrl)){
            $documentUrl = "index";
        }
        $documentUrl = strip_tags(str_replace('-', '_', $documentUrl));

        $templateLocation = "framework/views/docs/{$documentUrl}.tpl";

        if(!file_exists(_SITE_ROOT . $templateLocation)){
            // If the requested page doesn't exist, show a 404 error
            $this->page_template = 'page/four-o-four.tpl';
            header("HTTP/1.0 404 Not Found");   
            parent::render();            
            return;    
        }
        
        $this->page_template = $templateLocation;

        // Pass the current URL to the template
        $template->assign('currentUrl', "/documentation/{$documentUrl}");
        
        parent::render();
    }    
}
`;    
        
        let testPython = `\`\`\`python
#!/usr/bin/env python3

# ... existing imports ...

import urllib.request  # Python 3 import for urllib

# ... existing code ...

def download_file(local_filename, url):
    # Use urllib.request.urlretrieve for Python 3
    urllib.request.urlretrieve(url, local_filename)
    return local_filename

# ... existing code ...

class ProgressPercentage(object):
    def __call__(self, bytes_amount):
        # To simplify we'll assume this is hooked up
        # to a single filename.
        with self._lock:
            self._seen_so_far += bytes_amount
            percentage = (self._seen_so_far / self._size) * 100
            print("percentage now: {}".format(percentage))  # Use string formatting

# ... existing code ...

if __name__ == "__main__":
    # ... existing code ...

    while True:
        try:
            # ... existing code ...
        except Exception as e:  # Catch specific exception
            print("Unknown Error check logs: {}".format(str(e)))
        finally:
            print("sleeping 1 min")
            time.sleep(60)

    print("EXITED LOOP HOW???")

    sys.exit(0)  # Use explicit exit code
\`\`\``;
        
        var testCodeBlock = async function(codeBlock, file, fileContent){
            console.log("getting scopes");
            console.log(codeBlock);
            let theScopes = await DGRAPH.getTopLevelScopes(codeBlock, file, fileContent);        
            console.log("scopes");
            console.log(theScopes);        
        };
        let testFile1 = 'C:\\wamp\\www\\videomonitor\\video-monitor\\main.py';
        let testFileContent1 = fs.readFileSync(testFile1, 'utf-8');  
        await testCodeBlock(testPython, 'main.py', testFileContent1);
        
        //await testCodeBlock(test, 'myfile.js');
        //await testCodeBlock(test2, 'myfile.js');
        //await testCodeBlock(test3, 'testFile.php');
        
        //let desiredScopes = [1, [{start_line: "db.version(1).stores({", total_lines: 12}]];
        //await testCodeBlock(test4, 'anotherfile.js');
        //await testCodeBlock(test5, 'anotherfile.js');
        //await testCodeBlock(test6, 'test.php');
        //await testCodeBlock(test7, 'index.php');
        //await testCodeBlock(test8, 'framework\classes\documentation.php');
    });
    
    $('#test_markup_scope').on('click', async function(){
                
        let test1 = `// framework\views\header.tpl
//...

{if isset($base_href) && $base_href !== null}
    <base href="{$base_href->value}">
{/if}

//...`;
        
        let test2 = `//...
{if isset($market_alerts) && !empty($market_alerts)}
    {foreach from=$market_alerts item=malert}
    <div class="market-alert-container">
        <div class="lg-col-wrapper">
            <i class="market-alert-close fa fa-times-circle" aria-hidden="true"></i>
            <div class="market-alert-text">
                {$malert['message']}
            </div>
        </div>
    </div>
    {/foreach}
{/if}
<div id="mixedcontent"><span>What
        </span><ul>
        <li>adfsfsd</li>
        </ul>
    </div>
{foreach from="hey" item=what}
        <span>{$what}</span
{/foreach}
//...`;  
        var testMarkupBlock = async function(codeBlock, filename){
            console.log("getting scopes");
            console.log(codeBlock);
            let theScopes = await WEBFILE.getTopLevelMarkupScopes2(codeBlock, filename);
            console.log("scopes");
            console.log(theScopes);        
        };           
        
        console.log("TESTING MARKUP SCOPES, test 1");
        await testMarkupBlock(test1, 'framework\views\header.tpl');
        console.log("TESTING MARKUP SCOPES, test 2");        
        await testMarkupBlock(test2, 'framework\views\header.tpl');        
         
    });
    
    
    
    $('#test_line_structure').on('click', async function(){
        /*
        let testLine1 = 'for(let x = 0; x < groupOriginalPaths.length; x++){';
        let testFile1 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\embeddings.js';
        let testFilePath1 = 'js/embeddings.js';
        let testFileContent1 = fs.readFileSync(testFile1, 'utf-8');  
        
        let testLine2 = 'db.version(1).stores({';
        let testFile2 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\dexiedatabase.js';
        let testFilePath2 = 'js/dexiedatabase.js';
        let testFileContent2 = fs.readFileSync(testFile2, 'utf-8');          
        
        let testLine3 = 'CHATGPT.singleFilePartialChange = async function(filePath, partialOriginal, assistantMessage, tabUid){';
        let testFile3 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\chatgpt.js';
        let testFilePath3 = 'js/chatgpt.js';
        let testFileContent3 = fs.readFileSync(testFile3, 'utf-8');          
        
        let testLine4 = "$('body').on('click', '#show_history', async function(){";
        let testFile4 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\ui_handlers.js';
        let testFilePath4 = 'js/ui_handlers.js';
        let testFileContent4 = fs.readFileSync(testFile4, 'utf-8');          
                
       
        let largestControl = await DGRAPH.getLargestControlStructureForLine(testFilePath1, testLine1, testFileContent1);        
        console.log("TEST1 largest control structure");
        console.log(largestControl);                

        let largestControl2 = await DGRAPH.getLargestControlStructureForLine(testFilePath2, testLine2, testFileContent2);        
        console.log("TEST2 largest control structure");
        console.log(largestControl2);                
        
        let largestControl3 = await DGRAPH.getLargestControlStructureForLine(testFilePath3, testLine3, testFileContent3);        
        console.log("TEST3 largest control structure");
        console.log(largestControl3);           
        
        let largestControl4 = await DGRAPH.getLargestControlStructureForLine(testFilePath4, testLine4, testFileContent4);        
        console.log("TEST4 largest control structure");
        console.log(largestControl4);           
        */
        let testLine5 = 'if __name__ == "__main__":';
        let testFile5 = 'C:\\wamp\\www\\videomonitor\\video-monitor\\main.py';
        let testFilePath5 = 'main.py';
        let testFileContent5 = fs.readFileSync(testFile5, 'utf-8');        
        let largestControl5 = await DGRAPH.getLargestControlStructureForLine(testFilePath5, testLine5, testFileContent5);        
        console.log("TEST5 largest control structure");
        console.log(largestControl5);    
        
    });
    
    $("#test_treesit_html").on('click', async function(){
        //C:\wamp\www\stubs\stubs\framework\views\user\dashboard.tpl
        let origFile = "C:\\wamp\\www\\stubs\\stubs\\framework\\views\\user\\dashboard.tpl";
        let originalCode = fs.readFileSync(origFile, 'utf-8');  
        
        const lineCount = originalCode.split('\n').length;
        const allLines = originalCode.split('\n');
        
        for(let m = 0; m <= lineCount - 1; m++){
            /*
            console.log("=============");            
            console.log("at line " + m);
            let result = await TREESIT.getHtmlElementScopeForLine(originalCode, m, "tpl");
            console.log("treesit result");
            console.log(result);
            */
            console.log("=============");           
            let startLine = allLines[m];
            // Skip lines that start with </
            if(startLine.startsWith('</') || startLine.trim() == ''){
                continue;
            }            
            console.log("line" + m);
            console.log(startLine);
            console.log("WEBFILE RESULT ");
            let fallbackResult = await WEBFILE.getMarkupScopeFallback(originalCode, m + 1, ".tpl");
            console.log(fallbackResult);
            console.log("=============");

        }
    });
    
    
});

async function testSimpleEmbeddings(){
const documents = [
      {
        filename: "utility.js",
        description: "This file contains utility functions for string manipulation.",
        dependencies: [
          "file1.js calls function_x from utils.js",
          "file2.js calls function_y from file1.js",
        ],
      },
      {
        filename: "authorize.js",
        description: "This file handles user authentication and authorization.",
        dependencies: [
          "authorize.js calls function_y from utility.js",
          "authorize.js calls function_z from utility.js",
        ],
      },
      {
        filename: "ui_handlers.js",
        description: "This file handles setting up the UI.",
        dependencies: [
          "ui_handlers.js calls get_widgets() from utility.js",
          "ui_handlers.js calls get_layout() from utility.js",
        ],
      },  
    ];        
      const embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
      const query = "Find files related to building the UI";
      const mostSimilarIndices = await ipcRenderer.invoke('findMostSimilarDocumentIndices', query, embeddings, 3);
      let mostSimilarDocuments = mostSimilarIndices.map((index) => documents[index]);
      console.log("Most similar documents:", mostSimilarDocuments);    
}








//let uid = generateUID();
//console.log("test uid " + uid);

/*

*/

//random test code confusing things

/*
setTimeout(function(){
    console.log("Testing crawl Parser");
    CRAWL.testMarkdownConversion();
}, 1000);
 */

//for when I have modals
/*
document.addEventListener('DOMContentLoaded', () => {
  // Array of modal file paths
  const modalFiles = ['modals/settings_modal.html', 'modals/another_modal.html'];

  // Load and insert each modal file
  modalFiles.forEach(file => {
    fetch(file)
      .then(response => response.text())
      .then(html => {
        const body = document.querySelector('body');
        body.insertAdjacentHTML('beforeend', html);
      })
      .catch(error => {
        console.error('Error loading modal:', error);
      });
  });
});
*/

/*
async function testEmbeddings() {
  const documents = [
    {
      filename: "utility.js",
      description: "This file contains utility functions for string manipulation.",
      dependencies: [
        "file1.js calls function_x from utils.js",
        "file2.js calls function_y from file1.js",
      ],
    },
    {
      filename: "authorize.js",
      description: "This file handles user authentication and authorization.",
      dependencies: [
        "authorize.js calls function_y from utility.js",
        "authorize.js calls function_z from utility.js",
      ],
    },
    {
      filename: "ui_handlers.js",
      description: "This file handles setting up the UI.",
      dependencies: [
        "ui_handlers.js calls get_widgets() from utility.js",
        "ui_handlers.js calls get_layout() from utility.js",
      ],
    },
  ];

  try {
    const embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
    const query = "Find files related to building the UI";
    const mostSimilarIndices = await ipcRenderer.invoke('findMostSimilarDocumentIndices', query, embeddings, 3);
    //let mostSimilarDocuments = mostSimilarIndices.map((index) => documents[index]);
    console.log("Most similar indices:", mostSimilarIndices);
  } catch (error) {
    console.error('Error:', error);
  }
}

testEmbeddings();
*/

/*
let assistantMessage = `Here are the changes needed to complete the task:
 
 js\ui_handlers.js:
 
 \`\`\`javascript
 $(document).ready(function () {
   // ... existing code
   
   $('#add_link_context').on('click', function() {
     tippy(this, {
       content: \`
         <div>
           <input type="text" id="link_input" placeholder="Enter link">
           <button id="add_link_button">Add</button>
         </div>
       \`,
       interactive: true,
       trigger: 'click',
       allowHTML: true,
       onShow(instance) {
         const addButton = document.getElementById('add_link_button');
         addButton.addEventListener('click', () => {
           const linkInput = document.getElementById('link_input');
           const linkValue = linkInput.value;
           
           // Add the link to the current tab object
           const currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
           currentTab.link = linkValue;
           
           instance.hide();
         });
       }
     });
   });
   
   // ... existing code
 });
 \`\`\`
 
 js\tabmanager.js:
 
 \`\`\`javascript
 var TABS = TABS || {};
 
 TABS.CURRENT_INDEX = 0;
 TABS.CURRENT_UID = "";
 TABS.TAB_ARR = new Array();
 
 // ... existing code
 
 TABS.ADD_NEW_TAB = function(){
   // ... existing code
   
   let tabObject = {
     // ... existing properties
     link: "", // Add the link property to the tab object
     // ... existing properties
   };
   
   // ... existing code
 };
 
 // ... existing code
 \`\`\`
 
 These changes will:
 
 1. Add a click event listener to the \`add_link_context\` button.
 2. When clicked, show a tooltip using Tippy.js with a text field and an "Add" button.
 3. When the "Add" button in the tooltip is clicked, retrieve the link value from the text field and add it to the \`link\` property of the current tab object in \`TABS.TAB_ARR\`.
 4. Add the \`link\` property to the \`tabObject\` in the \`TABS.ADD_NEW_TAB\` function to ensure each new tab has a \`link\` property.
 
 With these changes, clicking the link button will show a tooltip where you can enter a link, and clicking the "Add" button will add the link to the current tab object.`;

setTimeout(function(){
    console.log("testssssss");
    let codeChanges = DIFFR.parseCodeChanges(assistantMessage);
    console.log("code changes test");
    console.log(codeChanges);    
}, 3000);
*/


/*
async function testParser(){
    let fileSmarty = "C:\\wamp\\www\\stubs\\stubs\\framework\\views\\home.tpl";
    let origData = readFileWithCache(fileSmarty);
    await STUBS.gotosleep(5000);
    console.log("testing invalid smarty file");
    console.log(origData);
    
    if (WEBFILE.quickHtmlValidate(origData)) {
         console.log("valid file");
    }else{
        console.log("invalid file");
    }
}
            setTimeout(function(){
                testParser();
            }, 1000);
*/




/*
async function testTreesitHtml(){
        console.log("getting control structure for html");

let fullFileData = `<div id="app-container">
    <div id="title-bar">
      <div id="title">Stubs - Supervised AI Autopilot</div>
      <div id="title-bar-btns">
        <button id="min-btn">-</button>
        <button id="max-btn">+</button>
        <button id="close-btn">x</button>
      </div>
    </div>
    <div id="file-menu">
      <ul>
        <li>
          <div class="file-menu-item">
            File
            <div class="file-dropdown">
              <a href="#" id="menu-add-project">Add New Project</a>
            </div>
          </div>
        </li>
        <li>
          <div class="file-menu-item">Edit
            <div class="file-dropdown">
              <a href="#" id="menu-settings">Settings</a> 
              <a href="#" id="menu-upgrade">Upgrade to Pro</a> 
            </div> 
          </div>
        </li>
        <li>
          <div class="file-menu-item">Tools
            <div class="file-dropdown">
              <a href="#" id="menu-planner">Feature Planner</a>                
              <a href="#" id="menu-debugger">Debugger</a>
              <a href="#" id="menu-database">Database</a>     
              <a href="#" id="menu-stubfiles">Stub Files</a>     
            </div>     
          </div>
        </li>        
        <li>
          <div class="file-menu-item">Help
            <div class="file-dropdown">
              <a href="#" id="menu-about">About</a>                
              <a href="#" id="menu-tutorial">Tutorial</a>
            </div>     
          </div>
        </li>        
      </ul>
      <div class="stubs_cost-container">
        <div class="day_cost">
          <span id="cost_label">Last 24h Cost</span> (estimate): <span id="today_cost">$0</span>
        </div>
        |
        <div class="day_tasks">
            Task Count: <span id="task_count">0</span>
        </div>      
      </div>
    </div>
   
    <div class="stubscontainer">
      <div class="main-content" id="dragmain-content">
        <div class="top-content" id="dragtop-content">
            <div style="display: flex;height: 100%;width: 100%;">
              <div>
                <div class="left-panel go_pro stubs_scroll-cus">
                  <div class="left-panel-rows">                    
                    <div class="button-panel">
                      <div class="next-button">
                      </div>                       
                    </div>
                  </div> 
                  <div id="progress-container">                      
                  </div>
                  <div id="directory-tree"></div>
                  <div></div>
                </div>
                <br><br><br>
              </div>
              <div id="upgrade_link" class="go_pro-container">
                <button class="stubs_btn stubs_btn_outline-primary darkmode">
                  <i class="ti ti-arrow-big-up-lines"></i> Go Pro
                </button>
              </div>
            </div>
        </div>
        <div class="bottom-content" id="dragbottom-content">
            <div class="resizer-horizontal" id="dragresizer-horizontal"></div>
            <div class="h-100">
              <div id="all_response_containers" class="stubs_scroll-cus">
              </div>   
            </div>
        </div>
      </div>
    </div>
</div>     
`;        
        console.log(fullFileData);
        //always do replace for the top level html scopes
        let controlStructure = await TREESIT.getHtmlElementScopeForLine(fullFileData, 47);
        console.log("html control structure");
        console.log(controlStructure);
};

testTreesitHtml();
*/


//testing some treee sitting 

//CHATGPT.estimateFileTokens("test");
//let file1 = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\ui_image_handlers.js";
//let fileData1 = fs.readFileSync(file1, 'utf-8');  
//should make this promise instead
/*
TREESIT.getFileStub(file1, "", function(finalText, md5){
    console.log("again");
    console.log(finalText);      
});
*/


//test dependency graph stuff
/*
setTimeout(async function(){
    let searchLine = "$('body').on('click', '#upload_image', function(){";    
    let cStruct = await DGRAPH.getControlStructureForLine(file1, searchLine, fileData1);

    console.log("Seraching for " + searchLine);
    console.log(cStruct);
}, 5000);
*/


//console.log("Testing Codemirror Stuff");
//let mergefile1 = "C:\\wamp\\www\\scrapehawk\\scrapehawk-extension\\contentscript_hawk.js";
//let mergefile2 = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\stubble\\scrapehawkext\\contentscript_hawk.js";

/*
let mergefile1 = "C:\\wamp\\www\\snipcss\\extension\\js\\selectionBox.js";
let mergefile2 = "C:\\wamp\\www\\scrapehawk\\scrapehawk-extension\\js\\selectionBox.js";


let fileData1 = fs.readFileSync(mergefile1, 'utf-8');  
let fileData2 = fs.readFileSync(mergefile2, 'utf-8');  
//console.log("filedata1");
//console.log(fileData1);
//console.log("filedata2");
//console.log(fileData2);

let origFileObj = {};
let modFileObj = {};

origFileObj['contentscript_hawk.js'] = fileData1;
modFileObj['contentscript_hawk.js'] = fileData2;


DIFFR.loadNewDiffs(new Array(), origFileObj, modFileObj, ['stubs'], false, TABS.TAB_ARR[0]['uid']);
*/



//console.log("mysqlconfig");
//console.log(mysqlConfig);

//CHATGPT.testDatabaseLogger(mysqlConfig);
